/****************************************************************************************************************************
**                                                                                                                         **
**                 Copyright (C) 1999 by Punk Productions Electronic Entertainment. All Rights Reserved.                   ** 
**                                                                                                                         **
**        Purpose: Everyone out there should be able to load different Imagefileformats...                                 **
**     Programmer: Nikolaus Brennig, 18, (Nikolaus.Brennig@nol.at)                                                         **
**                 Original ImageLoaderDLL coded by K. Nishita in 1997. I Only used it and created a simple DDloader       **
**                 for it. If you look in the code, its rather easy to use the Loadroutines for standard Win32Apps,        **
**                 since the Data is blitted to a DC, so do what you want with this code.                                  **
**                                                                                                                         **
**                 WARNING: If you want to use this code in a commercial product (game or whatever) you will have          **
**                 to send us ( Nishita and me, nick ) a free and full functional copy of it. Yep, thats business ;-)      **
**                 If you want to use this code only for learning or simply non-commercial use, simply send us an email    **
**                 cause for sure we want to know who out there uses this code...                                          **
**                                                                                                                         **
**                 You can contact us:       Nick: virtualnik@nol.at, http://cust.nol.at/ppee                              **
**                                     K. Nishita: knishita@ibm.net, http://freeware.freeservers.com                       **
**                                                                                                                         **
**                 Ok, thats all for now, so have fun with loading images ;-)                                              **
**                                                                                                                         **
**     Day created: January 12th, 1999                                                                                     **
**                                                                                                                         **
****************************************************************************************************************************/

// Headerfile...
#define WIN32_LEAN_AND_MEAN
#include "DDLoad.h" 

/*
** InitPC:
** Do the whole intialisation stuff...
*/
static BOOL InitPC( HINSTANCE hInstance, int nCmdShow )
{
    WNDCLASS            wc;
    DDSURFACEDESC       ddsd;
    DDSCAPS             ddscaps;
    HRESULT             ddrval;

    // Register the Window-class...
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
    wc.lpszMenuName = NAME;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );
    
    // Create the Window...
    hwnd = CreateWindowEx(
        0,
        NAME,
        TITLE,
        WS_POPUP,
        0,
        0,
        GetSystemMetrics(SM_CXSCREEN),
        GetSystemMetrics(SM_CYSCREEN),
        NULL,
        NULL,
        hInstance,
        NULL );
    if( !hwnd ) return Error("Window couldn't be created!!!");
    ShowWindow( hwnd, nCmdShow ); UpdateWindow( hwnd ); SetFocus( hwnd );

    // Load the free ImageLoaderDLL...
    InitImageViewerDLL();

    // Create the DirectDrawobject...
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if( ddrval != DD_OK ) return Error(" DDObject creation failed! " );

    // Now lets set the cooperativelevel of our application...
    ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
    if( ddrval != DD_OK ) return Error(" SetCooperativeLevel failed! " );

    // Now lets set the Displaymode: 640x480 in 32 bit Mode.
    ddrval = lpDD->SetDisplayMode( 640, 480, 16 );
    if( ddrval != DD_OK ) return Error(" SetDisplayMode failed! " );

    // Now we create the primary surface. This will receive the content of what you will see on the screen...
    ddsd.dwSize            = sizeof( ddsd );
    ddsd.dwFlags           = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps    = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 2;
    ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
    if( ddrval != DD_OK ) return Error("PrimarySurface creation failed! ");

    // Create the Backbuffer. To this surface the whole graphics stuff is drawn.
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack);
    if( ddrval != DD_OK ) return Error("Couldn't create the Backbuffer! ");

    // Create the second Backbuffer for triple buffering...
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack2);
    if( ddrval != DD_OK ) return Error("Couldn't create the second Backbuffer! ");

    // Now let's load our Testimages...ITS SO DAMNED COOL! ;-)
    lpDDSBMP = ReadImage( lpDD, "Test.bmp", 0, 0 ); if( lpDDSBMP == NULL )  return Error( "Loading Test.bmp failed! ");
    lpDDSDIB = ReadImage( lpDD, "Test.dib", 0, 0 ); if( lpDDSDIB == NULL )  return Error( "Loading Test.dib failed! ");
    lpDDSGIF = ReadImage( lpDD, "Test.gif", 0, 0 ); if( lpDDSGIF == NULL )  return Error( "Loading Test.gif failed! ");
    lpDDSJPG = ReadImage( lpDD, "Test.jpg", 0, 0 ); if( lpDDSJPG == NULL )  return Error( "Loading Test.jpg failed! ");
    lpDDSTGA = ReadImage( lpDD, "Test.tga", 0, 0 ); if( lpDDSTGA == NULL )  return Error( "Loading Test.tga failed! ");
    lpDDSPCX = ReadImage( lpDD, "Test.pcx", 0, 0 ); if( lpDDSPCX == NULL )  return Error( "Loading Test.pcx failed! ");

    // Ok, start the whole thing...
    ProgramState = PS_INITAPP;

    return TRUE;
} /* InitPC */

/*
** This function displays an Errormessage and terminates the app...
*/
BOOL Error( char *err )
{
  MessageBox( hwnd, err, "ImageLoader Sample, (C) 1999 Punk Productions", MB_ICONHAND+MB_OK );
  DestroyWindow ( hwnd );
  
 return FALSE;
} /* Error */

/*
** WinMain:
*/
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;
    
    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;
    if( !InitPC( hInstance, nCmdShow ) ) return Error("PC Initialization failed!");
    
    while( 1 )
    {
     if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
     {
      if( !GetMessage( &msg, NULL, 0, 0 ) )
          return msg.wParam;
      TranslateMessage(&msg); 
      DispatchMessage(&msg);
     }
     else if( bActive )
     {
      // App is active --> do the main procedure...
      HeartBeat();
     }
     else
     {
      // Ok, nothing to do, so do nothing :-))
      WaitMessage();
     }
    }
} /* WinMain */


